# -*- coding: utf-8 -*-
# Generated by Django 1.11.6 on 2020-07-17 16:42
from __future__ import unicode_literals

from django.db import migrations, models

class Migration(migrations.Migration):

    dependencies = [
        ('customers', '0035_auto_20200720_0948'),
    ]
    
    sql = """
    CREATE VIEW customers_financialrecord AS 
SELECT 'I'::text || customers_invoice.id::text AS record_id, false AS paid, 
customers_invoice.created_at AS ts,
        CASE
            WHEN (customers_invoice.kind <> 3) AND (customers_invoice.kind <> 9) THEN customers_invoice.total
            ELSE NULL::integer
        END AS charge,
        CASE
            WHEN (customers_invoice.kind = 3) OR (customers_invoice.kind = 9) THEN customers_invoice.total
            ELSE NULL::integer
        END AS credit,
    customers_invoice.comment,
    customers_invoice.customer_id
   FROM customers_invoice
  WHERE customers_invoice.paid_on IS NULL
UNION
 SELECT 'I'::text || customers_invoice.id::text AS record_id,
    true AS paid,
    customers_invoice.created_at AS ts,
        CASE
            WHEN  (customers_invoice.kind <> 3) AND (customers_invoice.kind <> 9) THEN customers_invoice.total
            ELSE NULL::integer
        END AS charge,
        CASE
            WHEN (customers_invoice.kind = 3) OR (customers_invoice.kind = 9) THEN customers_invoice.total
            ELSE NULL::integer
        END AS credit,
    customers_invoice.comment,
    customers_invoice.customer_id
   FROM customers_invoice
  WHERE customers_invoice.paid_on IS NOT NULL
UNION
 SELECT 'P'::text || customers_payment.id::text AS record_id,
    true AS paid,
    customers_payment.paid_on AS ts,
    NULL::integer AS charge,
    customers_payment.amount AS credit,
    customers_payment.comment,
    customers_payment.customer_id
   FROM customers_payment
  ORDER BY 3 DESC
    """

    balance_sql = """
    CREATE VIEW customers_balance AS 
    SELECT c.id,
    c.id AS customer_id,
    COALESCE(sum(fr.credit), 0::bigint) - COALESCE(sum(fr.charge), 0::bigint) AS balance
   FROM customers_customer c
     LEFT JOIN customers_financialrecord fr ON c.id = fr.customer_id
  GROUP BY c.id
    """

    sql_service = """
    CREATE VIEW customers_financialrecordservice AS 
 SELECT 'I'::text || customers_invoice.id::text AS record_id,
    false AS paid,
    customers_invoice.created_at AS ts,
        CASE
            WHEN  (customers_invoice.kind <> 3) AND (customers_invoice.kind <> 9) THEN customers_invoice.total
            ELSE NULL::integer
        END AS charge,
        CASE
            WHEN (customers_invoice.kind = 3) OR (customers_invoice.kind = 9) THEN customers_invoice.total
            ELSE NULL::integer
        END AS credit,
    customers_invoice.comment,
    customers_invoice.customer_id,
    customers_invoice_service.service_id
   FROM customers_invoice,
    customers_invoice_service
  WHERE customers_invoice_service.invoice_id = customers_invoice.id AND customers_invoice.paid_on IS NULL
  GROUP BY customers_invoice.id, customers_invoice_service.id
UNION
 SELECT 'I'::text || customers_invoice.id::text AS record_id,
    true AS paid,
    customers_invoice.created_at AS ts,
        CASE
            WHEN  (customers_invoice.kind <> 3) AND (customers_invoice.kind <> 9) THEN customers_invoice.total
            ELSE NULL::integer
        END AS charge,
        CASE
            WHEN (customers_invoice.kind = 3) OR (customers_invoice.kind = 9) THEN customers_invoice.total
            ELSE NULL::integer
        END AS credit,
    customers_invoice.comment,
    customers_invoice.customer_id,
    customers_invoice_service.service_id
   FROM customers_invoice,
    customers_invoice_service
  WHERE customers_invoice_service.invoice_id = customers_invoice.id AND customers_invoice.paid_on IS NOT NULL
  GROUP BY customers_invoice.id, customers_invoice_service.id
UNION
 SELECT 'P'::text || customers_payment.id::text AS record_id,
    true AS paid,
    customers_payment.paid_on AS ts,
    NULL::integer AS charge,
    customers_payment.amount AS credit,
    customers_payment.comment,
    customers_payment.customer_id,
    customers_payment_service.service_id
   FROM customers_payment,
    customers_payment_service
  WHERE customers_payment_service.payment_id = customers_payment.id
  GROUP BY customers_payment.id, customers_payment_service.id
  ORDER BY 3 DESC
    """

    balance_sql_service = """
    CREATE VIEW  customers_balanceservice AS 
 SELECT fr.customer_id AS id,
    fr.customer_id,
    COALESCE(sum(fr.credit), 0::bigint) - COALESCE(sum(fr.charge), 0::bigint) AS balance,
    fr.service_id
   FROM customers_financialrecordservice fr
  GROUP BY fr.customer_id, fr.service_id
    """

    operations = [
        migrations.RunSQL("DROP VIEW IF EXISTS customers_balance"),
        migrations.RunSQL("DROP VIEW IF EXISTS customers_financialrecord"),
        migrations.RunSQL(sql),
        migrations.RunSQL(balance_sql),
        migrations.RunSQL("DROP VIEW IF EXISTS customers_balanceservice"),
        migrations.RunSQL("DROP VIEW IF EXISTS customers_financialrecordservice"),
        migrations.RunSQL(sql_service),
        migrations.RunSQL(balance_sql_service),
    ]
